返回  

Windows中Python 2.7和Python 3.6兼容性问题及对应pip使用方法

2017-06-23 09:15:31 浏览:



Python 2和Python 3的同时使用

有很多人想学习Python3,但是暂时又离不开Python2,所以他们在Windows操作系统上同时安装了Python 2和python 3,但是在CMD.exe上面运行”python *.py”的时候只能执行其中的Python 2或者Python 3其中一种操作,那如何才能让它们共存,方便在两者之间切换呢?

目前,国内网站经常会让大家把其中一个python.exe改个名字以区分开两个可执行文件的名字。然而,上述操作会有一个重大的隐患,就是修改了名字的那个python对应的pip将无法正常使用。

官方的解法是什么?事实上这个问题几年以前Python社区就给出了官方解决方案,只不过国内一直没有注意到罢了。

1. 执行 py -X *.py 
我们在安装Python 3(>=3.3)时,Python的安装包实际上在系统中安装了一个启动器py.exe,默认放置在文件夹C:\Windows\下面。这个启动器允许我们指定使用Python 2还是Python 3来运行代码(当然前提是你已经成功安装了Python 2和Python 3)。

举个实际的例子: 
如果你有一个Python文件叫 hello.py,那么你想用Python 2运行它,可以执行

py -2 hello.py
  • 1
  • 1

类似的,如果你想用Python3运行它,可以执行

py -3 hello.py
  • 1
  • 1

2. 去掉参数 -2 / -3,执行 py *.py 
每次运行都要加入参数-2 / -3还是比较麻烦,所以py.exe这个启动器允许在代码中加入说明以表明这个文件应该是由python 2解释运行,还是由python 3解释运行。

说明的方法: 在代码文件的最开始加入下面其中一项即可表示该代码文件使用Python 2或者Python 3解释运行。

#! python2
  • 1
  • 1

或者

#! python3
  • 1
  • 1

因此,运行Python 程序时候命令可以简化为

py hello.py
  • 1
  • 1

使用pip

当Python2和Python3同时存在于windows上时,它们对应的pip都叫pip.exe,所以不能够直接使用 pip install 命令来安装软件包。而是要使用启动器py.exe来指定pip的版本。 
Python 2 pip install 安装软件命令如下:

py -2 -m pip install XXXX
  • 1
  • 1

其中,py -2 表示使用 Python2,-m pip 表示运行 pip 模块,即运行pip命令

以安装python 2.7的scipy模块为例

py -2 -m pip install "scipy-0.18.1-cp27-cp27m-win_amd64.whl"
  • 1
  • 1

Python 3 pip install 安装软件命令如下:

py -3 -m pip install XXXX
  • 1
  • 1

其中,py -3 表示使用 Python3,-m pip 表示运行 pip 模块,即运行pip命令

以安装python 3.5的scipy模块为例

py -3 -m pip install "scipy‑0.18.1‑cp35‑cp35m‑win_amd64.whl"
  •  
1

#! python2 和 # coding: utf-8 哪个写在前面?

对于Python2用户还有另外一个困惑,Python2要在代码文件顶部增加一行说明,才能够在代码中使用中文。如果指明使用的Python版本也需要在文件顶部增加一行,那哪一行应该放在第一行呢?

! python2 需要放在第一行,编码说明可以放在第二行。所以文件开头应该类似于:

#! python2
# coding: utf-8
分享到: